#
# spec file for package shellinabox
#
# Copyright (C) 2008-2009 Markus Gutschke <markus@shellinabox.com> and
#               ohan Persson <johan162@gmail.com>
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

BuildRequires:  libopenssl-devel pam-devel zlib-devel
PreReq:         pam openssl

Summary:        AJAX/Web based terminal emulator
Name:           shellinabox
#
%define pkg_name shellinabox
#
Version:        2.14
Release:        10.5
License:        SUSE-GPL-2.0-with-openssl-exception
URL:            http://code.google.com/p/shellinabox/
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
AutoReqProv:    on
Group:          Productivity/Networking/Web/Utilities
%define         shellinabox_user shellinabox
%define         pkg_home /var/lib/%{shellinabox_user}
Requires:	check-create-certificate


Source0: %{name}-%{version}.tar.bz2
# Fix possible buffer overwrite error in launcher.c
Patch:  shellinabox.patch
Patch1:  0001-add-new-keyCodes-used-by-FF15.patch
Source1: rcshellinabox
Source2: shellinabox

%description
Shell In A Box implements a web server that can export arbitrary command l
ine tools to a web based terminal emulator. This emulator is accessible to
any JavaScript and CSS enabled web browser and does not require any additional
browser plugins

All client-server communications are encrypted, if SSL/TLS certificates have been
installed.

Authors:
Markus Gutschke <markus@shellinabox.com>

%prep
%setup -q
%patch -p1
%patch1 -p1
# disable runtime loading (does not work properly),
# link the libraries directly
%configure --disable-runtime-loading

%build
make %{?_smp_mflags}

%install
%makeinstall

# remove INSTALL, not needed in installed package (fixes rpmlint warning)
rm $RPM_BUILD_ROOT/usr/share/doc/shellinabox/INSTALL

%{__install} -d -m 0755      \
    %{buildroot}%{pkg_home}/ \
    %{buildroot}%{_sbindir}

#
# init script
#
%{__install} -D -m 0755 -T %SOURCE1 \
    %{buildroot}%{_sysconfdir}/init.d/%{pkg_name}
%{__ln_s} -f %{_sysconfdir}/init.d/%{pkg_name} %{buildroot}%{_sbindir}/rc%{pkg_name}
#

# configure certificates
mkdir -p $RPM_BUILD_ROOT/etc/%{pkg_name}/certs

# firewall service definition
mkdir -p $RPM_BUILD_ROOT/etc/sysconfig/SuSEfirewall2.d/services
install -m 0644 %SOURCE2 $RPM_BUILD_ROOT/etc/sysconfig/SuSEfirewall2.d/services


%post
%fillup_and_insserv

%clean
%__rm -rf %{buildroot}

%pre
/usr/sbin/groupadd -r %{shellinabox_user} >/dev/null 2>&1 ||:
/usr/sbin/useradd -g %{shellinabox_user} -s /bin/false -r -c "user for %{shellinabox_user}" -d %{pkg_home} %{shellinabox_user} >/dev/null 2>&1 ||:


# ---------------------------------------------------------------------------------
%preun
%stop_on_removal
/sbin/chkconfig --del shellinabox

# ---------------------------------------------------------------------------------
# Cleanup after install
# ---------------------------------------------------------------------------------
%postun
%restart_on_update shellinabox
%insserv_cleanup
test -e /var/run/shellinabox.pid  || rm -rf /var/run/shellinabox.pid && :

# ---------------------------------------------------------------------------------
# FILES
# ---------------------------------------------------------------------------------
%files

%defattr(-,root,root)
%attr(-,%{shellinabox_user},%{shellinabox_user}) %dir %{pkg_home}
%{_initrddir}/shellinabox
%doc %attr(0444,root,root) %{_mandir}/man1/shellinaboxd.1*
%doc /usr/share/doc/shellinabox
%{_bindir}/shellinaboxd
%dir /etc/shellinabox/
%dir /etc/shellinabox/certs
%{_sbindir}/rc%{pkg_name}
%config /etc/sysconfig/SuSEfirewall2.d/services/shellinabox

%changelog
* Mon Nov 10 2014 Led <ledest@gmail.com>
- fix bashisms in pre script
* Wed Aug 14 2013 lslezak@suse.cz
- use "--disable-runtime-loading" configure option - fixes not
  working SSL support loading at runtime (links SSL library
  directly at build time)
- use 127.0.0.1 SSH host name if the machine host name cannot be
  resolved
* Thu Feb  7 2013 lslezak@suse.cz
- added Susefirewall service description file
- restart on update
- do not package INSTALL file
* Wed Feb  6 2013 lslezak@suse.cz
- fixed not working "_" and "-" keys in Firefox (bnc#793123)
  (in 0001-add-new-keyCodes-used-by-FF15.patch file)
* Wed Feb  6 2013 lslezak@suse.cz
- updated to version 2.14:
  - removed executable stack flags in binary
  - blinking cursor can be disabled
  - optional on-screen keyboard
  - fixed some scaling related issues
- removed shellinabox-ia64-ppc-s390.patch (build has been fixed in
  upstream Makefiles)
- removed libopenssl-devel runtime dependency
* Wed Nov 28 2012 lslezak@suse.cz
- use check-create-certificate for creating SSL certificate
* Tue Oct 16 2012 lslezak@suse.cz
- rcshellinabox - fixed syntax error "HOSTNAME: command not found",
  display the fingerprint after creating new certificate
  (to allow easy verification in browser)
* Wed Jul 11 2012 lslezak@suse.cz
- fixed build on IA64 and S390
* Mon Apr 16 2012 cfarrell@suse.com
- license update: SUSE-GPL-2.0-with-openssl-exception
  See COPYING. SUSE- prefix is used until upstream (spdx.org) accept
  GPL-2.0-with-openssl-exception
* Mon Apr  2 2012 dvaleev@suse.com
- fix build on powerpc
* Tue Nov 15 2011 schubi@suse.com
-  cleanup spec file. added rc script
* Wed Oct  5 2011 vlewin@suse.com
-  Enable SSL and use WebYaST certificate
* Mon Sep  5 2011 vlewin@suse.de
- Initial build.
